﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Olap.Data;
using Infragistics.Controls.Grids;
using System.Collections.ObjectModel;
using Infragistics.Olap.FlatData;
using Infragistics.Olap.Xmla;
using System.Windows.Threading;
using System.Linq.Expressions;

namespace CheckBoxHeaders
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }


        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            loadDimentsionsInit();

        }


        public List<PartnerPercentage> myList;
        private void loadDimentsionsInit()
        { 
            try
            {


                //populating some data
                myList = new List<PartnerPercentage>();
                for (int i = 0; i < 5; i++)
                    for (int j = 9; j >= 0; j--)
                        myList.Add(new PartnerPercentage { Investment = "Investment" + i, Name = "P" + j, Percentage = (double)j / 100 });

                FlatDataSource flatDataSource = new FlatDataSource
                {
                    ItemsSource = myList,
                    Cube = XmlaDataSource.GenerateInitialCube("PartnerPercentage"),
                    Columns = XmlaDataSource.GenerateInitialItems("[Investment].[Investment]"),
                    Rows = XmlaDataSource.GenerateInitialItems("[Name].[Shown Partner Header]"),

                    Measures = XmlaDataSource.GenerateInitialItems("Percentage"),



                };
                       CubeMetadata cubeMetadata = new CubeMetadata();
                cubeMetadata.DisplayName = "Partner Percentage Matrix";
                cubeMetadata.DataTypeFullName = typeof(PartnerPercentage).FullName;
                cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
                {
                    SourcePropertyName = "Percentage",
                    DisplayName = "Percentage",
                    DisplayFormat = "{0:P4}"
                });
                cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
                {
                    SourcePropertyName = "Investment",
                    DisplayName = "Investment"
                });


                flatDataSource.CubesSettings.Add(cubeMetadata);

                // Define hierarchies
                HierarchyDescriptor<PartnerPercentage> partnerHierarchy = new HierarchyDescriptor<PartnerPercentage>(p => p.Name);
                partnerHierarchy.HierarchyName = "Shown Partner Header";
                partnerHierarchy.AddLevel(p =>
                    "all",
                    "All partners"
                    );
                partnerHierarchy.AddLevel(p =>
                    p.Name,
                    "Partner name"
                    );
                flatDataSource.AddHierarchyDescriptor(partnerHierarchy);

                HierarchyDescriptor<PartnerPercentage> investmentHierarchy = new HierarchyDescriptor<PartnerPercentage>(p => p.Investment);
                investmentHierarchy.AddLevel(p =>
                    "All investments",
                    "All investments"
                    );
                investmentHierarchy.AddLevel(p =>
                    p.Investment,
                    "Investment name"
                    );
                flatDataSource.AddHierarchyDescriptor(investmentHierarchy);
                this.pivotGrid.DataSource = flatDataSource;
                this.dataSelector.DataSource = flatDataSource;
            }
                 catch (Exception ex)
            {
                MessageBox.Show("LoadPivotGridWithSampleData - " + ex.Message);
            }

        }



        int steps = 1;
        private void pivotGrid_LayoutLoaded(object sender, EventArgs e)
        {
            if (steps==1)
            {
               pivotGrid.GridLayout.RowHeaderCells[0].IsExpanded = true;
                steps = 2;
            }
           
        }

        private void pivotGrid_LayoutUpdated(object sender, EventArgs e)
        {
            if (steps==2 &&pivotGrid != null && pivotGrid.GridLayout != null && pivotGrid.GridLayout.RowHeaderCells.Count > 3)
            {
                (pivotGrid.DataSource as FlatDataSource).SwitchMemberSortDirection(pivotGrid.DataSource.Result.RowAxis.Tuples[pivotGrid.DataSource.Result.RowAxis.Tuples.Count-1].Members[0]);
                steps = 3;                
            }
    
        }

    }

}
